#!/usr/bin/perl
#
# Steve Poirier - steve@inet-technologies.com
# edited by Tim Allwine tallwine@oreilly.com
# to use with RT2 and MySQL

use strict;
use DBI;

# definition of variables
my $db="rttest";
my $host="localhost";
my $user="rt";
my $password="pass";

# you don't need to modify anything below this line

if ($db eq "rttest") {
	print "First, you must edit this file with your favorite editor\n";
	print "and configure db variables.\n";
	exit;
}

print "************************************************************\n";
print "\nWarning, this script will delete all Tickets from your system\n";
print "that are marked 'dead'. You can NOT recover the tickets once deleted.\n";
print "You SHOULD backup your DB before. Use it at your own risk.\n";
print "************************************************************\n";
print "Press enter to proceed or control-c to abort: ";
my $a = <STDIN>;

my $ticketnbr = 0;

# connect to MySQL database
my $dbh   = DBI->connect ("DBI:mysql:database=$db:host=$host",
                          $user,
                          $password) 
    or die "Can't connect to database: $DBI::errstr\n";

# prepare the query for dead tickets

my $sql = ('SELECT id FROM Tickets where Status=?');
my $sth = $dbh->prepare($sql);
$sth->execute('dead');

my $d_sth = $dbh->prepare('SELECT id FROM Transactions where Ticket=?');
my $stid = $dbh->prepare('DELETE FROM Attachments WHERE TransactionId=?');
my $sttrans = $dbh->prepare( 'DELETE FROM Transactions WHERE Ticket=?');
my $stwatch = $dbh->prepare( 'DELETE FROM Watchers WHERE Value=?');
my $stobjects =$dbh->prepare( 'DELETE FROM ObjectKeywords WHERE ObjectId=?');
my $stticket = $dbh->prepare( 'DELETE FROM Tickets WHERE id=?');

# proceed with deletion
while ( my ($ticketid) = $sth->fetchrow_array() )  {
    print "\nticket $ticketid is dead. Deleting:  ";
    $d_sth->execute($ticketid);

# delete Attachments for this ticket
    print "Attachments. ";
    while ( my ($transid) = $d_sth->fetchrow_array() )  {
	$stid->execute($transid);
    }

# delete Ticket in Transactions table
    print "Transactions. ";
    $sttrans->execute($ticketid);

# delete Ticket in ticket in Watchers table
    print "Watchers. ";
    $stwatch->execute($ticketid);

# delete Ticket in ObjectKeywords table
    print "ObjectKeywords. ";
    $stobjects->execute($ticketid);

# delete Ticket from the Tickets table
    print "Ticket. ";
    $stticket->execute($ticketid);

    $ticketnbr++;
}
print "\nDone. Deleted $ticketnbr tickets.\n\n";

exit;
